#OPEN tAI TABLE
f=open("tAI.csv")
tAI=[]
i=0

import math
def geomean(numbers):       ##Geometric mean of tAIs from all codons, for faculties not approaching 0
    product = 1
    for n in numbers:
        product *= n
    return product ** (1.0/len(numbers))

def geomeanlog(numbers):    ##Geometric mean of tAIs from all codons using log transformation
    summ=0
    for n in numbers:
        summ+=math.log10(n)
    logG=summ/len(numbers)
    return 10**logG
    

##Split comma-separated values
for line in f:
    linje=line.split(";")
    tAI.append(linje)
    tAI[i][1]=tAI[i][1].rstrip()
    i+=1
f.close()



toggle=1

##Run program
while toggle==1:
    ##Open/create outputfile
    f=open('output.csv','w')
    print 'Please remember to copy the output.csv file for every analysis if you want to keep it.'
    sequ=raw_input("Type / Paste sequence in CAPS! Whitespace allowed, exclude stop codon: ")

    seq=''
    for i in range(0,len(sequ)):
        if sequ[i]=='A'or sequ[i]=='T'or sequ[i]=='C'or sequ[i]=='G':
            seq+=sequ[i]


    #ASSIGN tAI to individual codons
    a=0
    b=3
    codons=[]
    values=[]
    strings=['Codon no;tAI\n']
    if (len(seq)%3)==0:
        while a<len(seq):
            codons.append(seq[a:b])
            a+=3
            b+=3
        
        for x in range(0,len(codons)):
            for i in range(1,65):
                if codons[x]==tAI[i][0]:
                    codons[x]=[codons[x],tAI[i][1]]
                    values.append(float(tAI[i][1]))
                    strings.append(str(x+1)+';'+str(values[x])+'\n')
                    
            
        
    ##Geometric mean of tAIs from all codons
        tai=geomeanlog(values)

        ##Write to outputfile
        f.writelines(strings)
        f.close()

        ##Display results
        print codons
        print "The tAI of the given sequence is: ",tai
        print"Would you like to analyze one more sequence?"
        ans=raw_input("yes / no: ")
        if 'yes' not in ans:
            
            f.close()
            toggle=0
    else:
        print "Invalid number of bases!"
        print"Would you like to analyze on more sequence?"
        ans=raw_input("yes / no: " )
        if ans!='yes':
            toggle=0
            f.close()
            
print "Thank you for using this awesome program!"
f.close()




